"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.hasPermissions = void 0;
/**
 * Determines if the user has permissions, based on the permission kind value
 */
exports.hasPermissions = function (permissionMask, permissions) {
    if (permissions === void 0) { permissions = []; }
    // Set the permissions
    var requestedPermissions = typeof (permissions) === "number" ? [permissions] : permissions;
    // Default the permission flag
    var hasPermissions = true;
    // See if this user has full permissions
    if (((permissionMask.High & 32767) == 32767) && ((permissionMask.Low & 65535) == 65535)) {
        return hasPermissions;
    }
    // Parse the requested permissions
    for (var i = 0; i < requestedPermissions.length; i++) {
        var permission = requestedPermissions[i];
        // Determine the value to use
        var sequence = permissionMask.Low;
        if (permission >= 32) {
            // Update the sequence
            sequence = permissionMask.High;
            permission -= 32;
        }
        // See if the user doesn't have permission
        if ((sequence & (1 << (permission - 1))) == 0) {
            // Set the flag and break from the loop
            hasPermissions = false;
            break;
        }
    }
    // Return the result
    return hasPermissions;
};
